> ## Documentation Index
> Fetch the complete documentation index at: https://docs.teal.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List all tag rules

> Lists all tag rules.



## OpenAPI

````yaml GET /v0/tags/rules
openapi: 3.1.0
info:
  title: Teal API
  version: '0.1'
servers:
  - url: https://api.sandbox.teal.dev
    description: Sandbox
  - url: https://api.teal.dev
    description: Production
security: []
paths:
  /v0/tags/rules:
    get:
      tags:
        - Tags
      summary: List all tag rules
      description: Lists all tag rules.
      operationId: get_tag_rules_v0_tags_rules_get
      parameters:
        - name: ids
          in: query
          required: false
          schema:
            anyOf:
              - items:
                  type: string
                type: array
              - type: 'null'
            description: >-
              A comma separated list of Tag Rule IDs. Only return Tag Rules with
              the specified IDs. Returns 404 if an ID is not found, 403 if any
              ID is not authorized.
            teal_explode: false
            title: Ids
          description: >-
            A comma separated list of Tag Rule IDs. Only return Tag Rules with
            the specified IDs. Returns 404 if an ID is not found, 403 if any ID
            is not authorized.
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            exclusiveMaximum: 1001
            description: The number of records to return. Max limit is 1000.
            default: 50
            title: Limit
          description: The number of records to return. Max limit is 1000.
        - name: page_token
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Opaque page token
            title: Page Token
          description: Opaque page token
        - name: teal-instance-id
          in: header
          required: true
          schema:
            type: string
            description: The teal instance ID
            title: Teal-Instance-Id
          description: The teal instance ID
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TagRulePage'
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TealErrorResponse'
          description: Forbidden
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TealErrorResponse'
          description: Not Found
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TealErrorResponse'
          description: Unprocessable Content
        '503':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TealErrorResponse'
          description: Service Unavailable
      security:
        - OAuth2PasswordBearer: []
components:
  schemas:
    TagRulePage:
      properties:
        next_page_token:
          anyOf:
            - type: string
            - type: 'null'
          description: The token to use to request the next page
          examples:
            - ikal0NEVfMhF8dJf4yQ6KQZmGD
        prev_page_token:
          anyOf:
            - type: string
            - type: 'null'
          description: The token to use to request the previous page
          examples:
            - vuA7JeKI5c6FLnPt5JfRcZcJxW
        records:
          items:
            $ref: '#/components/schemas/TagRule'
          type: array
          title: Records
          description: A list of tag rules.
          examples:
            - - expression: match(".*(?i)SHELL GAS", t.description)
                id: yB2xokXpQb5S1NgyWsNCwG
                name: Tag gas expense
                priority: 10
                tag_id: NCB2xo5S1yQbNgyWskXpwG
      type: object
      required:
        - next_page_token
        - prev_page_token
        - records
      title: TagRulePage
    TealErrorResponse:
      properties:
        message:
          anyOf:
            - type: string
            - type: 'null'
          title: Message
          description: A description of the error for API developers.
        data:
          title: Data
          description: Data associated with the error.
        display_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Display Message
          description: A description of the error for end users.
        error_code:
          anyOf:
            - $ref: '#/components/schemas/TealErrorCode'
            - type: 'null'
          description: Error code associated with the error.
      type: object
      required:
        - message
      title: TealErrorResponse
    TagRule:
      properties:
        id:
          type: string
          title: Id
          description: The unique ID of the object.
          examples:
            - yB2xokXpQb5S1NgyWsNCwG
        name:
          type: string
          title: Name
          description: An arbitrary string, useful for identifying the tag rule.
          examples:
            - Tag gas expense
        tag_id:
          type: string
          title: Tag Id
          description: If the rule finds a match, the ID of the tag that will be assigned.
          examples:
            - NCB2xo5S1yQbNgyWskXpwG
        expression:
          type: string
          title: Expression
          description: >-
            A pattern matching expression using the match(pattern, field)
            function. Use `t` to access the Transaction object. The pattern
            supports regular expression syntax.


            Read more: [Categorization
            guide](https://docs.teal.dev/guides/platform/categorization/rules#expressions)
          examples:
            - match(".*(?i)SHELL GAS", t.description)
        priority:
          type: integer
          title: Priority
          description: The priority of the rule.
          examples:
            - 10
      type: object
      required:
        - id
        - name
        - tag_id
        - expression
        - priority
      title: TagRule
    TealErrorCode:
      type: string
      enum:
        - invalid_date
        - invalid_ledger
        - missing_parameters
        - duplicate_name
        - duplicate_sort_code
        - invalid_ledger_type
        - invalid_ledger_report_cash_flow
        - deleting_required_ledger
        - repeated_tag_group
        - deleting_transaction_line
        - modifying_read_only_ledger
        - debits_credits_not_equal
        - modifying_opening_balance_journal_entry
        - modifying_accrual_journal_entry
        - modifying_payment_application_journal_entry
        - invalid_deferral_ledger
        - duplicate_statement_ending_date
        - reconciliation_in_progress
        - reconciled_balance_does_not_match
        - journal_entry_outside_reconciliation_period
        - parsed_statement_balance_mismatch
        - entries_start_date_after_transactions
        - entries_start_date_after_reconciliations
        - entries_start_date_after_journal_entries
      title: TealErrorCode
  securitySchemes:
    OAuth2PasswordBearer:
      type: oauth2
      description: >-
        Bearer authentication header of the form Bearer <token>, where <token>
        is your auth token.
      flows:
        password:
          scopes: {}
          tokenUrl: https://developer.teal.dev

````